// C Source File
// Created 14/02/02; 18:31:38


#define USE_TI92PLUS				// Produce .9xz File
#define USE_TI89					// Produce .89z File
//#define USE_V200				// En prvision de la Voyage 200 PLT


// Options proposes par TIGCC
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization


#include <tigcclib.h>         // Include All Header Files


#define version "0.95"
#ifndef version
#warning Pas de numro de version (remplac par X . XX)
#define version "X.XX"
#endif

// Pour afficher des informations au cours de l'excution.
//#define test

// Variables de types personnaliss...
typedef struct
{
	char nom[11];
	unsigned long points;
} HGS;

typedef struct
{
	short type;
	unsigned short xe;
	unsigned short ye;
} POINT;

// Variables globales
BITMAP *save0=NULL;
BITMAP *save1=NULL;
HGS scores[5]={{"TI-SPLASH", 5000}, {version, 4000}, {"par", 3000}, {"DOUALOT", 2000}, {"Nicolas", 1000}};
long temps=0;
POINT precedent={0, 0, 0}, nouveau={0, 0, 0};
SCR_RECT *screen=NULL;
unsigned short accel=0, bombe=0, hand=0, level=0, ltype[4]={0, 0, 0, 0}, perdu=0, (*plateau)[10]=NULL, score=0, x=0, xe=0, y=0, ye=0;


// Headers pour le fonctionnement du programme
#include "splashi.h"					// Les images d'intro
#include "splashp.h"					// Plateau de jeu
#include "son.h"						// Pour jouer des sons
#include "cache.h"					// Pour dssiner des rectangles en niveau de gris
#include "getkey.h"					// Gestion personnalise de _rowread
#include "presentation.h"			// Programme du menu d'avant jeu
#include "arene.h"					// Pour dessiner l'ecran de jeu
#include "tuyau.h"					// Les cartes prdfinies
#include "perdu1.h"					// Premiere image lorsque le joueur  perdu
#include "perdu2.h"					// Deuxieme image lorsque le joueur  perdu
#include "gagne1.h"					// Premiere image lorsque le joueur  gagn
#include "gagne2.h"					// Deuxieme image lorsque le joueur  gagn


// Prototypes des fonctions...
short deplace(short, short);			// Gestion du joueur
void eau(short, short);					// Mouvement de l'eau dans les tuyaux

// Dplacement de l'eau
void eau(short _height, short _width)
{
	short k;
	unsigned short prec=precedent.type;
	if ((nouveau.type=plateau[ye][xe]))
	{
		cache(_width-40+8*xe, _height-36+8*ye, _width-33+8*xe, _height-29+8*ye, 0, 3);
		Sprite8(_width-40+8*xe, _height-36+8*ye, 8, nouveau.type==1 ? sprt1_e : nouveau.type==2 ? sprt2_e : nouveau.type==3 ? sprt3_e : nouveau.type==4 ? sprt4_e : nouveau.type==5 ? sprt5_e : sprt6_e, GetPlane(0), SPRT_XOR);
		Sprite8(_width-40+8*xe, _height-36+8*ye, 8, nouveau.type==1 ? sprt1_e : nouveau.type==2 ? sprt2_e : nouveau.type==3 ? sprt3_e : nouveau.type==4 ? sprt4_e : nouveau.type==5 ? sprt5_e : sprt6_e, GetPlane(1), SPRT_XOR);
		son(85, 2);
		son(100,2);
		plateau[ye][xe]=7;
		if (xe==x && ye==y)
		{
			// Changement du fond sauvegard
			// Zone  sauvegarder
			screen->xy.x0=_width-40+8*x;
			screen->xy.y0=_height-36+8*y;
			screen->xy.x1=_width-33+8*x;
			screen->xy.y1=_height-29+8*y;
			for (k=0; k<=1; k++)
			{
				SetPlane(k);
				BitmapGet(screen, k ? save1 : save0);
			}
			cache(_width-40+8*x, _height-36+8*y, _width-33+8*x, _height-29+8*y, 0, 3);
			Sprite8(_width-40+8*x, _height-36+8*y, 8, ltype[0]==1 ? sprt1_0 : ltype[0]==2 ? sprt2_0 :ltype[0]==3 ? sprt3_0 : ltype[0]==4 ? sprt4_0 : ltype[0]==5 ? sprt5_0 : sprt6_0, GetPlane(0), SPRT_XOR);
			Sprite8(_width-40+8*x, _height-36+8*y, 8, ltype[0]==1 ? sprt1_1 : ltype[0]==2 ? sprt2_1 :ltype[0]==3 ? sprt3_1 : ltype[0]==4 ? sprt4_1 : ltype[0]==5 ? sprt5_1 : sprt6_1, GetPlane(1), SPRT_XOR);
		}
	}
	switch (nouveau.type)
	{
		case 1:
			if (ye+1!=precedent.ye && ye-1!=precedent.ye) perdu=1;
			if (ye-1==precedent.ye)
			{
				if (prec==5 || prec==1 || prec==4) ye++;
				else perdu=1;
			}
			if (ye+1==precedent.ye)
			{
				if (prec==6 || prec==1 || prec==3) ye--;
				else perdu=1;
			}
			break;

		case 2:
			if (xe+1!=precedent.xe && xe-1!=precedent.xe) perdu=1;
			if (xe-1==precedent.xe)
			{
				if (prec==3 || prec==2 || prec==4) xe++;
				else perdu=1;
			}
			if (xe+1==precedent.xe)
			{
				if (prec==5 || prec==6 || prec==2) xe--;
				else perdu=1;
			}
			break;

		case 3:
			if (xe+1!=precedent.xe && ye-1!=precedent.ye) perdu=1;
			if (ye-1==precedent.ye)
			{
				if (prec==5 || prec==1 || prec==4) xe++;
				else perdu=1;
			}
			if (xe+1==precedent.xe )
			{
				if (prec==6 || prec==2 || prec==5) ye--;
				else perdu=1;
			}
			break;

		case 4:
			if (xe+1!=precedent.xe && ye+1!=precedent.ye) perdu=1;
			if (xe+1==precedent.xe)
			{
				if (prec==6 || prec==2 || prec==5) ye++;
				else perdu=1;
			}
			if (ye+1==precedent.ye)
			{
				if (prec==3 || prec==1 || prec==6) xe++;
				else perdu=1;
			}
			break;

		case 5:
			if (xe-1!=precedent.xe && ye+1!=precedent.ye) perdu=1;
			if (xe-1==precedent.xe)
			{
				if (prec==3 || prec==2 || prec==4) ye++;
				else perdu=1;
			}
			if (ye+1==precedent.ye)
			{
				if (prec==3 || prec==1 || prec==6) xe--;
				else perdu=1;
			}
			break;

		case 6:
			if (xe-1!=precedent.xe && ye-1!=precedent.ye) perdu=1;
			if (ye-1==precedent.ye)
			{
				if (prec==4 || prec==5 || prec==1) xe--;
				else perdu=1;
			}
			if (xe-1==precedent.xe)
			{
				if (prec==3 || prec==2 || prec==4) ye--;
				else perdu=1;
			}
			break;

		default :
			perdu=1;
	}
	precedent.type=nouveau.type;
	precedent.xe=nouveau.xe;
	precedent.ye=nouveau.ye;
	nouveau.type=plateau[ye][xe];
	nouveau.xe=xe;
	nouveau.ye=ye;
	if (!perdu) score+=10+level+hand;
	if (ye==7 && xe==9) perdu=2;

}


// Dplacement des lments
short deplace(short _height, short _width)
{
	// Variables locales.
	// k variable pour les boucles...
	// key varable qui retient la valeur renvoye par la touche appuye...
	short k, key;

	key=getkey(1, 0);

	if (key)
	{
		// Diminue le temps pour contrebalancer l'appuis sur une touche...
		temps--;
		// Efface l'lment.
		for (k=0; k<=1; k++)
		{
			SetPlane(k);
			BitmapPut( _width-40+8*x, _height-36+8*y, k ? save1 : save0, screen, A_REPLACE);
		}
	}

	// Oups!! le prof arrive
	if (key==265) off();

	//Acclerre l'coulement de l'eau
	if (key==269 && !accel)
	{
		accel=1;
		temps=temps>20 ? 20 : temps;
		son(1000, 50);
		son(1500, 75);
	}

	// Quitter le jeu
	if (key==264) perdu=1;

	// Placement d'un lment
	if (key==13 && !(plateau[y][x]))
	{
		plateau[y][x]=ltype[0];
		for (k=0; k<4; k++)
		{
			// Efface la liste des lments suivant.
			Sprite8(_width+51, _height-14+11*k, 8, ltype[k]==1 ? sprt1 : ltype[k]==2 ? sprt2 :ltype[k]==3 ? sprt3 : ltype[k]==4 ? sprt4 : ltype[k]==5 ? sprt5 : sprt6, GetPlane(0), SPRT_XOR);
			Sprite8(_width+51, _height-14+11*k, 8, ltype[k]==1 ? sprt1 : ltype[k]==2 ? sprt2 :ltype[k]==3 ? sprt3 : ltype[k]==4 ? sprt4 : ltype[k]==5 ? sprt5 : sprt6, GetPlane(1), SPRT_XOR);	
		}
		// Affiche l'lment.
		cache(_width-40+8*x, _height-36+8*y, _width-33+8*x, _height-29+8*y, 0, 3);
		Sprite8(_width-40+8*x, _height-36+8*y, 8, ltype[0]==1 ? sprt1 : ltype[0]==2 ? sprt2 :ltype[0]==3 ? sprt3 : ltype[0]==4 ? sprt4 : ltype[0]==5 ? sprt5 : sprt6, GetPlane(0), SPRT_XOR);
		Sprite8(_width-40+8*x, _height-36+8*y, 8, ltype[0]==1 ? sprt1 : ltype[0]==2 ? sprt2 :ltype[0]==3 ? sprt3 : ltype[0]==4 ? sprt4 : ltype[0]==5 ? sprt5 : sprt6, GetPlane(1), SPRT_XOR);
		for (k=1; k<4; k++)
		{
			ltype[k-1]=ltype[k];
		}
		ltype[3]=(random(60)%6)+1;
		for (k=0; k<4; k++)
		{
			// Affiche la nouvelle liste des lments suivant.
			Sprite8(_width+51, _height-14+11*k, 8, ltype[k]==1 ? sprt1 : ltype[k]==2 ? sprt2 :ltype[k]==3 ? sprt3 : ltype[k]==4 ? sprt4 : ltype[k]==5 ? sprt5 : sprt6, GetPlane(0), SPRT_XOR);
			Sprite8(_width+51, _height-14+11*k, 8, ltype[k]==1 ? sprt1 : ltype[k]==2 ? sprt2 :ltype[k]==3 ? sprt3 : ltype[k]==4 ? sprt4 : ltype[k]==5 ? sprt5 : sprt6, GetPlane(1), SPRT_XOR);	
		}
	}

	if (key==268 && plateau[y][x] && plateau[y][x]!=7 && bombe)
	{
		//Effacement d'une des bombe de la liste.
		Sprite8(_width+65, _height-3+11*(3-bombe), 8, sprtb0, GetPlane(0), SPRT_XOR);
		Sprite8(_width+65, _height-3+11*(3-bombe), 8, sprtb1, GetPlane(1), SPRT_XOR);

		// Le joueur  utilis une bombe.
		bombe--;

		// Action de la bombe...
		plateau[y][x]=0;
		cache(_width-40+8*x, _height-36+8*y, _width-33+8*x, _height-29+8*y, 0, 3);
		Sprite8(_width-40+8*x, _height-36+8*y, 8, sprtf, GetPlane(0), SPRT_XOR);
		Sprite8(_width-40+8*x, _height-36+8*y, 8, sprtf, GetPlane(1), SPRT_XOR);

		// Changement du fond
		screen->xy.x0=_width-40+8*x;
		screen->xy.y0=_height-36+8*y;
		screen->xy.x1=_width-33+8*x;
		screen->xy.y1=_height-29+8*y;
		for (k=0; k<=1; k++)
		{
			SetPlane(k);
			BitmapGet(screen, k ? save1 : save0);
		}
		//key=13;
	}

	if (key==1 && x!=1) x--;					// Touche gauche

	if (key==2 && x!=8) x++;				// Touche droite

	if (key==3 && y!=1) y--;					// Touche haut

	if (key==4 && y!=7) y++;				// Touche bas

	if (key==1 || key==2 || key==3 || key==4)
	{
		son(392, 1);
		son(587, 2);
	}

	if (key==13 || key==264)
	{
		// Son
		son(294, 1);
		son(261, 2);	
	}

	if (key)
	{
		screen->xy.x0=_width-40+8*x;
		screen->xy.y0=_height-36+8*y;
		screen->xy.x1=_width-33+8*x;
		screen->xy.y1=_height-29+8*y;
		for (k=0; k<=1; k++)
		{
			SetPlane(k);
			BitmapGet(screen, k ? save1 : save0);
		}
		// Affiche l'lment.
		cache(_width-40+8*x, _height-36+8*y, _width-33+8*x, _height-29+8*y, 0, 3);
		Sprite8(_width-40+8*x, _height-36+8*y, 8, ltype[0]==1 ? sprt1_0 : ltype[0]==2 ? sprt2_0 :ltype[0]==3 ? sprt3_0 : ltype[0]==4 ? sprt4_0 : ltype[0]==5 ? sprt5_0 : sprt6_0, GetPlane(0), SPRT_XOR);
		Sprite8(_width-40+8*x, _height-36+8*y, 8, ltype[0]==1 ? sprt1_1 : ltype[0]==2 ? sprt2_1 :ltype[0]==3 ? sprt3_1 : ltype[0]==4 ? sprt4_1 : ltype[0]==5 ? sprt5_1 : sprt6_1, GetPlane(1), SPRT_XOR);
	}

	return key;
}


// Fonction principale
void _main(void)
{
	char curfold[10], *sscore=NULL, TIOSname[10];
	FILE *highs;
	LCD_BUFFER  *screens=(LCD_BUFFER*)malloc(3840);
	short _height, key, _width;

	// Sauvegarde de l'AUTO_INT_1...
	INT_HANDLER handsave1=GetIntVec(AUTO_INT_1);
	//INT_HANDLER handsave5=GetIntVec(AUTO_INT_5);

	_height=LCD_HEIGHT/2;
	_width=LCD_WIDTH/2;
	LCD_save(screens);
	screen=(SCR_RECT*)malloc(10);
	save0=(BITMAP*)malloc(120);
	save1=(BITMAP*)malloc(120);
	sscore=(char*)malloc(6);
	

	// Lecture ou cration du ficher des records
	TIOSname[0]=0;
	FolderGetCur(curfold);
	FolderCur($(main), FALSE);
	if ((highs=fopen("splashs","rb")))
	{
		fread(&level, 2, 1, highs);
		fread(&hand, 2, 1, highs);
		fread(scores, 5*sizeof(HGS), 1, highs);
		fclose(highs);
	}

	// Allocation de l'espace pour la matrice reprsentant l'aire de jeu
	plateau=calloc(9, sizeof(*plateau));


	//Activation des niveaux de gris...
	SetIntVec(AUTO_INT_1, DUMMY_HANDLER);
	//SetIntVec(AUTO_INT_5, DUMMY_HANDLER);
	while (!IsGrayMode()) GrayOn();


	do
	{

		// Menu d'avant jeu.
		do
		{
			(*screen).xy.x0=_width-76;
			(*screen).xy.y0=_height-46;
			(*screen).xy.x1=_width+76;
			(*screen).xy.y1=_height+46;
			key=presentation(intro0, intro1, _height, _width);
		}
		while (key!=264 && key!=13);
		if (key==264) goto end;

		// Initialisation des variables pour une nouvelle partie.
		// Initialisation des variables...
		score=0;
		do
		{
			perdu=0;						// Pour savoir si le joueur  perdu
			randomize();
			memset(plateau, 0, 10 * 9 * 2);
			plateau[0][0]=1;
			plateau[7][9]=2;
			randomize();
			tuyau(random(7));
			for (key=0; key<4; key++) ltype[key]=(random(60)%6)+1;
			// Dessin de la zone de jeu.

			// Pieces du handicap.
			for (key=0; key<(signed)hand; key++)
			{
				short k, l;
				do
				{
					k=random(7)+1;
					l=random(8)+1;
				}
				while (plateau[k][l]);
				plateau[k][l]=(random(60)%6)+1;
			}
			arene(splashp0, splashp1, _height, _width);
	
			// Position de joueur au dbut.
			x=5;
			xe=1;
			y=4;
			ye=1;
			// Nouvelle position de l'eau.
			nouveau.type=plateau[1][1];
			nouveau.xe=1;
			nouveau.ye=1;
			// Ancienne position de l'eau.
			precedent.type=1;
			precedent.xe=0;
			precedent.ye=0;
			// Temps pour que l'eau avance.
			temps=300-10*level;
			FontSetSys(F_8x10);

			// Boucle pour jouer
			// Variables devant reprendre leur tat au dbut de chaque partie...
			accel=0;
			bombe=3;						// Nombre de bombes
			FontSetSys(F_6x8);
			do
			{
				// Dplacement de l'eau dans les tuyaux.
				if (temps--<=0)
				{
					eau(_height, _width);
					temps=300-10*(accel ? 29 : level);
				}
				// Affichage du score et du level.
				sprintf(sscore, "%05hu", score);
				for (key=0; key<=1; key++)
				{
					SetPlane(key);
#ifndef test
					DrawStrXY( _width-72, _height-11, sscore, A_REPLACE);
#endif
				}
			}
			while (deplace(_height, _width)!=264 && !perdu);
	
			// Le joueur a gagn
			if (perdu==2)
			{
				void image1()
				{
					for (key=0; key<=1; key++)
					{
						SetPlane(key);
						BitmapPut(_width-29, _height-29, key ? gagne11 : gagne10, ScrRect, A_REPLACE);
					}
				}
	
				void image2()
				{
					for (key=0; key<=1; key++)
					{
						SetPlane(key);
						BitmapPut(_width-29, _height-29, key ? gagne21 : gagne20, ScrRect, A_REPLACE);
					}
				}
				image1();
				son(294,9);
				son(370,9);
				image2();
				son(440,9);
				son(587,9);
				image1();
				son(440,9);
				son(370,9);
				image2();
				son(294,9);
				son(370,9);
				image1();
				son(440,9);
				son(587,9);
				image2();
				son(440,9);
				son(370,9);
				image1();
				son(440,14);
				son(392,14);
				image2();
				son(370,14);
				son(330,14);
				image1();
				son(294,27);
				son(440,9);
				image2();
				son(294,9);
				son(440,9);
				image1();
				son(587,33);
				key=getkey(2, 2);
				if (key!=264)
				{
					score+=50*level;
					level++;
				}
			}
	
			// Le joueur  perdu
			if (perdu==1)
			{
				void image1()
				{
					for (key=0; key<=1; key++)
					{
						SetPlane(key);
						BitmapPut(_width-29, _height-29, key ? perdu11 : perdu10, ScrRect, A_REPLACE);
					}
				}
	
				void image2()
				{
					for (key=0; key<=1; key++)
					{
						SetPlane(key);
						BitmapPut(_width-29, _height-29, key ? perdu21 : perdu20, ScrRect, A_REPLACE);
					}
				}
				son(622,11);
				son(494,11);
				image2();
				son(466,11);
				son(415,11);
				image1();
				son(622,11);
				son(494,11);
				image2();
				son(466,11);
				son(415,11);
				image1();
				son(311,11);
				son(415,11);
				image2();
				son(466,11);
				son(493,11);
				image1();
				son(466,11);
				son(415,11);
				image2();
				son(370,11);
				son(349,11);
				image1();
				son(311,40);
				getkey(2, 2);
				key=264;
			}
			// Son
			son(500, 2);
		}
		while (level<=20 && perdu==2 && key!=264);

		// Actualisation de la table des records en fin de partie.
		if (score>=scores[4].points)
		{
			char *high=(char *)malloc(33);
			unsigned short lettre0[]={0xFE00,0xFE00,0xFE00,0xFE00,0xFE00,0xFE00,0xFE00,0xFE00,0xFE00};
			short j, k, l, x, y;

			// Affichage de l'image informant le joueur qu'il a tabli un record.
			for (k=0; k<=1; k++)
			{
				SetPlane(k);
				BitmapPut(_width-29, _height-29, k ? record1 : record0, ScrRect, A_REPLACE);
			}
			getkey(2, 2);

			// Position du joueur dans la table des records.
			for (key=0; key<4; key++)
			{
				if (score>=scores[key].points) break;
			}

			// Dplacement vers le bas des dtenteurs de records infrieur  celui du joueur
			for (k=4; k>key; k--)
			{
				scores[k].points=scores[k-1].points;
				strcpy(scores[k].nom,scores[k-1].nom);
			}

			// Enregistrement du score du joueur.
			scores[key].points=score;

			// Enregistrement du nom du joeur.
			cache(_width-74,_height-33,_width+74,_height+33,0,3);
			FontSetSys(F_6x8);
			sprintf(high, "%d.            %05lu", key+1, scores[key].points);
			for (k=0; k<=1; k++)
			{
				SetPlane(k);
				DrawStrXY(_width-57, _height-29, high, A_NORMAL);
			}
			l=x=y=0;
			memset(scores[key].nom,0,10);
			for (k=0; k<=4; k++)
			{
				for (j=0; j<=(k<=3 ? 17 : 2); j++)
				{
					DrawChar(_width-71+8*j, _height-14+9*k, 48+18*k+j, A_REPLACE);
				}
			}
			DrawStrXY(_width-45, _height+22, "[ ] [\x15] Annuler Fin", A_REPLACE);
			while (k!=-1)
			{
				for (k=0; k<=1; k++)
				{
					SetPlane(k);
					DrawStrXY(_width-10-DrawStrWidth(scores[key].nom, F_6x8)/2, _height-29, scores[key].nom, A_REPLACE);
				}
				SetPlane(0);
				if (y==4 && x==3) cache(_width-43, _height+21, _width-28, _height+29, A_XOR, 0);
				if (y==4 && x==4) cache(_width-19, _height+21, _width-4, _height+29, A_XOR, 0);
				if (y==4 && x==5) cache(_width+2, _height+21, _width+45, _height+29, A_XOR, 0);
				if (y==4 && x==6) cache(_width+51, _height+21, _width+69, _height+29, A_XOR, 0);
				if (y<4 || (y==4 && x<3)) Sprite16(_width-71+8*x, _height-15+9*y, 9, lettre0, GetPlane(0), SPRT_XOR);
				while (!(k=getkey(1,0)));
				if (y==4 && x==3) cache(_width-43, _height+21, _width-28, _height+29, A_XOR, 0);
				if (y==4 && x==4) cache(_width-19, _height+21, _width-4, _height+29, A_XOR, 0);
				if (y==4 && x==5) cache(_width+2, _height+21, _width+45, _height+29, A_XOR, 0);
				if (y==4 && x==6) cache(_width+51, _height+21, _width+69, _height+29, A_XOR, 0);
				if (y<4 || (y==4 && x<3)) Sprite16(_width-71+8*x, _height-15+9*y, 9, lettre0, GetPlane(0), SPRT_XOR);
				switch (k)
				{
					case 1:
						x--;
						break;
					case 2:
						x++;
						break;
					case 3:
						y--;
						break;
					case 4:
						y++;
						break;
					case 13:
						if (y==4 && x==4 && l)
						{
							l--;
							scores[key].nom[l]=0;
							for (k=0; k<=1; k++)
							{
								SetPlane(k);
								DrawStrXY(_width-40, _height-29, "          ", A_REPLACE);
							}
						}
						if (y==4 && x==5) { strcpy(scores[key].nom,"Inconnu"); k=-1; }
						if (y==4 && x==6) k=-1;
						if (y==4 && x==3)
						{
							scores[key].nom[l]=32;
							l++;
						}
						if ((y<4 || (y==4 && x<3)) && l<10)
						{
							scores[key].nom[l]=48+18*y+x;
							l++;
						}
						if (l==10) { y=4; x=6; }
						break;
					case 264:
						strcpy(scores[key].nom,"Inconnu");
						k=-1;
						break;
				}
				x=(x<0 ? (y!=4 ? 17 : 6) : x);
				x=(x>(y!=4 ? 17 : 6) ? 0 : x);
				y=(y<0 ? 4 : y);
				y=(y>4 ? 0 : y);
			}

			//Affichage du nouveau classement.
			record(_height, _width);

			//Liberation de l'espace allou dynamiquement pour high;
			free(high);
		}
		level=level>20 ? 20 : level;
	}
	while (1);


end:
	// Dsactivation des niveaux de gris...
	while (IsGrayMode()) GrayOff();
	SetIntVec(AUTO_INT_1, handsave1);
	//SetIntVec(AUTO_INT_5, handsave5);

	// Dsarchive de la variable de stockage des parametres et la rend visible.
	if (EM_moveSymFromExtMem($(splashs), HS_NULL)) (DerefSym(SymFind($(splashs))))->flags.bits.hidden=0;

	// Sauvegarde des records
	FolderCur($(main), FALSE);
	if ((highs=fopen("splashs","wb")))
	{
		fwrite(&level, 2, 1, highs);
		fwrite(&hand, 2, 1, highs);
		fwrite(scores, 5*sizeof(HGS), 1, highs);
		fputc(0,highs);
		fputs("SAV",highs);
		fputc(0,highs);
		fputc(OTH_TAG,highs);
		fclose(highs);
	}

	// Archivage de la variable de stockage des parametres
	EM_moveSymToExtMem($(splashs), HS_NULL);

	// Rend la variable de sauvegarde des paramtres invisible.
	(DerefSym(SymFind($(splashs))))->flags.bits.hidden=1;
	FolderCur(strcpy(TIOSname+1, curfold)+strlen(curfold), TRUE);

	// Libration de l'espace allou dynamiquement dans la fonction main...
	free(save0);
	free(save1);
	free(sscore);
	free(plateau);
	free(screen);

	// Temporisation
	OSFreeTimer(USER_TIMER);
	OSRegisterTimer(USER_TIMER, 4);
	while (!OSTimerExpired(USER_TIMER));

	// Redemmarage de l'APD_timer (extinction automatique de la calculatrice.
	OSTimerRestart(APD_TIMER);

	// On vide la mmoire des touches appuyes.
	GKeyFlush();

	// Affichage de la sauvegarde de l'cran.
	LCD_restore(screens);
	free(screens);

	// Efface l'indicateur "BUSY" de la status line.
	ST_busy(3);

	// Phrase  al fin du jeu.
	ST_helpMsg("SLUBMAN & J2T (http:\\\\www.j2t.fr.st)");
}
