// C Header File
// Created 19/02/02; 16:46:23
//Trac du cadre de jeu.

#ifndef __SYSTEM
#include <system.h>
#endif

#ifndef __GRAPH
#include <graph.h>
#endif

//Prototype de la fonction
void arene(BITMAP*, BITMAP*, short, short);					// Dessin de la zone de jeu

void arene(BITMAP *splashp0, BITMAP *splashp1, short _height, short _width)
{
	//Variables locales...
	//k variables pour les boucles...
	char *levels=NULL, *scores=NULL;
	short k;
	WIN_RECT area;

	levels=(char*)malloc(3);
	scores=(char*)malloc(6);

	//Dessin du contour de la zone de jeu.
	area.x0=_width-75;
	area.y0=_height+34;
	area.x1=_width+75;
	area.y1=_height+36;
	for (k=0; k<=1; k++)
	{
		SetPlane(k);
		DrawClipRect(&area, screen, A_NORMAL);
	}

	// Dessin du fond du plateau de jeu.
	for (k=0; k<=1; k++)
	{
		SetPlane(k);
		BitmapPut(_width-74, _height-33, k==0 ? splashp0 : splashp1, ScrRect, A_REPLACE);
	}

	// Affichage du score et du level.
	sprintf(levels, "%02hu", level);
	sprintf(scores, "%05hu", score);
	for (k=0; k<=1; k++)
	{
		SetPlane(k);
#ifndef test
		FontSetSys(F_6x8);
		DrawStrXY( _width-72, _height-11, scores, A_REPLACE);
		FontSetSys(F_8x10);
		DrawStrXY( _width-65, _height+16, levels, A_REPLACE);
#endif
	}

	// Dessin des lments suivants, dans la colonne prvue  cet effet.
	for (k=0; k<4; k++)
	{
		Sprite8(_width+51, _height-14+11*k, 8, ltype[k]==1 ? sprt1 : ltype[k]==2 ? sprt2 :ltype[k]==3 ? sprt3 : ltype[k]==4 ? sprt4 : ltype[k]==5 ? sprt5 : sprt6, GetPlane(0), SPRT_XOR);
		Sprite8(_width+51, _height-14+11*k, 8, ltype[k]==1 ? sprt1 : ltype[k]==2 ? sprt2 :ltype[k]==3 ? sprt3 : ltype[k]==4 ? sprt4 : ltype[k]==5 ? sprt5 : sprt6, GetPlane(1), SPRT_XOR);	
	}
	for (k=0; k<3; k++)
	{
		Sprite8(_width+65, _height-3+11*k, 8, sprtb0, GetPlane(0), SPRT_XOR);
		Sprite8(_width+65, _height-3+11*k, 8, sprtb1, GetPlane(1), SPRT_XOR);
	}
	// L'eau dans la premiere portion.
	unsigned char sprt[]={ 0x3C, 0x3C, 0x3C, 0x3C, 0xFF, 0x0, 0x0, 0x0};
	cache(_width-32, _height-33, _width-25, _height-29, 0, 3);
	Sprite8(_width-32, _height-33, 5, sprt, GetPlane(0), SPRT_XOR);
	Sprite8(_width-32, _height-33, 5, sprt, GetPlane(1), SPRT_XOR);

	// Dessin de la tuyauterie au dbut.
	for (x=1; x<9; x++)
	{
		for(y=1; y<8; y++)
		{
			if (plateau[y][x])
			{
				cache(_width-40+8*x, _height-36+8*y, _width-33+8*x, _height-29+8*y, 0, 3);
				Sprite8(_width-40+8*x, _height-36+8*y, 8, plateau[y][x]==1 ? sprt1 : plateau[y][x]==2 ? sprt2 : plateau[y][x]==3 ? sprt3 : plateau[y][x]==4 ? sprt4 : plateau[y][x]==5 ? sprt5 : sprt6, GetPlane(0), SPRT_XOR);
				Sprite8(_width-40+8*x, _height-36+8*y, 8, plateau[y][x]==1 ? sprt1 : plateau[y][x]==2 ? sprt2 : plateau[y][x]==3 ? sprt3 : plateau[y][x]==4 ? sprt4 : plateau[y][x]==5 ? sprt5 : sprt6, GetPlane(1), SPRT_XOR);
			}
		}
	}

	screen->xy.x0=_width-36;
	screen->xy.y0=_height-5;
	screen->xy.x1=_width+36;
	screen->xy.y1=_height+5;
	for (k=0; k<=1; k++)
	{
		SetPlane(k);
		BitmapGet(screen, k ? (BITMAP*)save1 : (BITMAP*)save0);
	}
	// Donne le temps au joueur de se prparer, par des boucles de 1 seconde.
	OSFreeTimer(USER_TIMER);
	OSRegisterTimer(USER_TIMER, 10);
	while (!OSTimerExpired(USER_TIMER));
	for (k=0; k<=1; k++)
	{
		SetPlane(k);
		DrawStrXY(_width-36, _height-5, " Prt??? ", A_REPLACE);
	}
	OSFreeTimer(USER_TIMER);
	OSRegisterTimer(USER_TIMER, 20);
	son(300, 10);
	while (!OSTimerExpired(USER_TIMER));
	for (k=0; k<=1; k++)
	{
		SetPlane(k);
		DrawStrXY(_width-36, _height-5, "Partez!!!", A_REPLACE);
	}
	OSFreeTimer(USER_TIMER);
	OSRegisterTimer(USER_TIMER, 20);
	son(300, 10);
	while (!OSTimerExpired(USER_TIMER));
	for (k=0; k<=1; k++)
	{
		SetPlane(k);
		BitmapPut(_width-36, _height-5, k ? save1 : save0, screen, A_REPLACE);
	}
	son(600, 50);

	// Sauvegarde du fond sous le premier lment.
	screen->xy.x0=_width;
	screen->xy.y0=_height-4;
	screen->xy.x1=_width+7;
	screen->xy.y1=_height+3;
	for (k=0; k<=1; k++)
	{
		SetPlane(k);
		BitmapGet(screen, k ? save1 : save0);
	}
	// Dessin du premier lment en effaant le fond.
	cache(_width, _height-4, _width+7, _height+3, 0, 3);
	Sprite8(_width, _height-4, 8, ltype[0]==1 ? sprt1_0 : ltype[0]==2 ? sprt2_0 :ltype[0]==3 ? sprt3_0 : ltype[0]==4 ? sprt4_0 : ltype[0]==5 ? sprt5_0 : sprt6_0, GetPlane(0), SPRT_XOR);
	Sprite8(_width, _height-4, 8, ltype[0]==1 ? sprt1_1 : ltype[0]==2 ? sprt2_1 :ltype[0]==3 ? sprt3_1 : ltype[0]==4 ? sprt4_1 : ltype[0]==5 ? sprt5_1 : sprt6_1, GetPlane(1), SPRT_XOR);

	free(levels);
	free(scores);
}
